function x = h3_isfield(s, f)
% returns TRUE if the structure "s" contains a field "f"
% in addition to isfield(s, f), this function handles following cases:
%   h3_isfield(s, 'T1.x.y.z')


% Copyright is with the following author(s):
%
% (C) 2008-2010 Michal Kvasnica, Slovak University of Technology
%               michal.kvasnica@stuba.sk

% ------------------------------------------------------------------------
% Legal note:
%       This program is free software; you can redistribute it and/or
%       modify it under the terms of the GNU General Public
%       License as published by the Free Software Foundation; either
%       version 2.1 of the License, or (at your option) any later version.
%
%       This program is distributed in the hope that it will be useful,
%       but WITHOUT ANY WARRANTY; without even the implied warranty of
%       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%       General Public License for more details.
%
%       You should have received a copy of the GNU General Public
%       License along with this library; if not, write to the
%       Free Software Foundation, Inc.,
%       59 Temple Place, Suite 330,
%       Boston, MA  02111-1307  USA
%
% ------------------------------------------------------------------------


if isempty(s)
    x = false;
    return
end
if isempty(f)
    x = true;
    return
end
n = fieldnames(s);
[first, last] = strtok(f, '.');
x = strmatch(first, n, 'exact');
if isempty(x)
    x = false;
else % isfield(s, first)
    x = h3_isfield(getfield(s, first), last);
% else
%     x = false;
end
